%testing for big data demo

%create dataset for the demo

%how many variables? how many dimensions?
dim = 40;
n = 10000;%number of points in each class 
k = 6; %number of classes
goodDIM = floor(dim*.3);%percent of the dimensions that are good 
temp = 5;

data = zeros(n*k,dim);
y = zeros(size(data,1),1);%labels

%mixture of gaussians in these dimensions
for j = 1:dim
    for i = 1:k
        if j <= goodDIM
            a = rand;
            b = temp*rand;
            data((i-1)*n+1:n*i, j) = a.*randn(n,1) + b;
            
            if j == 1
                y((i-1)*n+1:n*i) = i;
            end
            
        else
            data((i-1)*n+1:n*i, j) = temp.*rand(n,1)+rand*temp/2;
        end
    end
end

% subplot(1,2,1)
% scatter(data(:,1),data(:,2))
% subplot(1,2,2)
% scatter(data(:,38),data(:,45))

%then do a randperm and mix the dimensions around
newM = randperm(size(data,1));
MixedData = data((newM),randperm(dim));
Y = y(newM);
% subplot(1,2,1)
% scatter(MixedData(:,1),MixedData(:,2))
% subplot(1,2,2)
% scatter(MixedData(:,38),MixedData(:,45))

save('data.mat','MixedData','k','Y')